#-----------------------------------------------------------------------------
%{?!dist:	%define	dist	.ok}
%global		verslibsolv	0.7.25
%global		sname		zypp
#-----------------------------------------------------------------------------
Name		:	libzypp
Version		:	17.31.20
Release		:	14.4.0.0%{?dist}
Summary		:	Library for package, patch, pattern and product management
Group		:	Applications/System

Packager	:	Osukiss Project	<build-ok@osukiss.org>

License		:	GPL-2.0+
URL		:	https://github.com/openSUSE/libzypp

Source0		:	%{name}-%{version}.tar.gz
#to prevent a2x call
Source1		:	%{name}-ok_addon.tar.gz
#-----------------------------------------------------------------------------
BuildRequires	:	asciidoc
BuildRequires	:	boost-devel
BuildRequires	:	cmake
Buildrequires	:	docbook-xml
Buildrequires	:	docbook-xsl
BuildRequires	:	libsolv-devel	>=	%{verslibsolv}
BuildRequires	:	libproxy
BuildRequires	:	libxslt
BuildRequires	:	gettext
BuildRequires	:	gpgme
BuildRequires	:	protobuf-devel
BuildRequires	:	protobuf-lite-devel
BuildRequires	:	yaml-cpp

Requires	:	zypp-common	=	%{version}-%{release}
Requires	:	libsolv-tools	>=	%{verslibsolv}
#-----------------------------------------------------------------------------
%description
'%{name}' is the package management library that powers applications
like YaST, zypper and the openSUSE/SLE implementation of PackageKit.

libzypp provides functionality for a package manager:

  * An API for package repository management, supporting most common
    repository metadata formats and signed repositories.
  * An API for solving packages, products, patterns and patches
    (installation, removal, update and distribution upgrade
    operations) dependencies, with additional features like locking.
  * An API for commiting the transaction to the system over a rpm
    target. Supporting deltarpm calculation, media changing and
    installation order calculation.

#-----------------------------------------------------------------------------
%files			
%defattr(-,root,root,-)
%license COPYING
%{_libdir}/%{name}.so.*
%{_libexecdir}/zypp/

#-----------------------------------------------------------------------------
%postun
/usr/sbin/ldconfig

%post
/usr/sbin/ldconfig
#=============================================================================
%package -n		zypp-common
Summary		:       Common files for ZYpp

BuildArch	:	noarch

#-----------------------------------------------------------------------------
%description -n		zypp-common
This package provides the common files expected by %{name}
and its consumers

#-----------------------------------------------------------------------------
%files -n		zypp-common -f zypp.lang
%config(noreplace) %{_sysconfdir}/%{sname}/zypp.conf
%config(noreplace) %{_sysconfdir}/%{sname}/systemCheck
%config(noreplace) %{_sysconfdir}/%{sname}/needreboot
%config(noreplace) %{_sysconfdir}/logrotate.d/%{sname}-history.lr
%dir %{_sharedstatedir}/%{sname}/
%dir %attr(750,root,root) %{_localstatedir}/log/%{sname}
%dir %{_localstatedir}/cache/%{sname}
%dir %{_libexecdir}/%{sname}
%{_datadir}/%{sname}/schema/yum/*.rng
%{_mandir}/man5/locks.5.gz

#=============================================================================
%package -n		zypp-plugins
Summary		:       Plugins for %{name} users

Requires	:	zypp-common = %{version}-%{release}

Provides	:	libzypp(plugin) = 0.1
Provides	:	libzypp(plugin:appdata) = 0
Provides	:	libzypp(plugin:commit) = 1
Provides	:	libzypp(plugin:services) = 1
Provides	:	libzypp(plugin:system) = 1
Provides	:	libzypp(plugin:urlresolver) = 0
Provides	:	libzypp(repovarexpand) = 1.1

BuildArch	:	noarch
#-----------------------------------------------------------------------------
%description -n		zypp-plugins
The zypp-plugins package contains various plugin binaries used
by consumers of %{name}.

#-----------------------------------------------------------------------------
%files -n		zypp-plugins
%{_libexecdir}/zypp/plugins/

#=============================================================================
%package -n		zypp-tools
Summary		:       Tools for %{name} users

Requires	:	%{name} = %{version}-%{release}

#-----------------------------------------------------------------------------
%description -n		zypp-tools
The zypp-tools package contains tools shipped for consumers
of %{name} to use.

#-----------------------------------------------------------------------------
%files -n		zypp-tools
%{_bindir}/%{sname}-*
%{_libexecdir}/%{sname}/%{sname}-rpm
%{_mandir}/man1/%{sname}-*.1.gz

#=============================================================================
%package		devel
Summary		:       Development files for %{name}

Requires	:	%{name} = %{version}-%{release}
Requires	:	libsolv
Requires	:	boost

#-----------------------------------------------------------------------------
%description		devel
The %{name}-devel package contains libraries and header files for
developing applications that use %{name}.

#-----------------------------------------------------------------------------
%files			devel
%{_includedir}/%{sname}/*.tcc
%{_includedir}/%{sname}-core/KVMap
%{_includedir}/%{sname}-core/OnMediaLocation
%{_includedir}/%{sname}-core/*.h
%{_includedir}/%{sname}-core/base/*
%{_includedir}/%{sname}-core/fs/*
%{_includedir}/%{sname}-core/parser/*
%{_includedir}/%{sname}-core/ui/*
%{_includedir}/%{sname}-core/url/*
%{_includedir}/%{sname}-curl/CurlConfig
%{_includedir}/%{sname}-curl/ProxyInfo
%{_includedir}/%{sname}-curl/TransferSettings
%{_includedir}/%{sname}-curl/*.h
%{_includedir}/%{sname}-curl/auth/*
%{_includedir}/%{sname}-curl/proxyinfo/*
%{_includedir}/%{sname}-curl/parser/*
%{_includedir}/%{sname}-media/CDTools
%{_includedir}/%{sname}-media/FileCheckException
%{_includedir}/%{sname}-media/MediaConfig
%{_includedir}/%{sname}-media/MediaException
%{_includedir}/%{sname}-media/Mount
%{_includedir}/%{sname}-media/*.h
%{_includedir}/%{sname}-media/auth/AuthData
%{_includedir}/%{sname}-media/auth/CredentialFileReader
%{_includedir}/%{sname}-media/auth/CredentialManager
%{_includedir}/%{sname}-media/auth/*.h
%{_includedir}/%{sname}-media/ng/DeviceDriver
%{_includedir}/%{sname}-media/ng/HeaderValueMap
%{_includedir}/%{sname}-media/ng/MediaVerifier
%{_includedir}/%{sname}-media/ng/MountingWorker
%{_includedir}/%{sname}-media/ng/Provide*
%{_includedir}/%{sname}-media/ng/*.h
%{_includedir}/%{sname}/*.h
%{_includedir}/%{sname}/base/*.h
%{_includedir}/%{sname}/media/*.h
%{_includedir}/%{sname}/media/proxyinfo/*.h
%{_includedir}/%{sname}/misc/*.h
%{_includedir}/%{sname}/parser/*.h
%{_includedir}/%{sname}/parser/susetags/*.h
%{_includedir}/%{sname}/parser/xml/*.h
%{_includedir}/%{sname}/parser/yum/*.h
%{_includedir}/%{sname}/pool/*.h
%{_includedir}/%{sname}/repo/*.h
%{_includedir}/%{sname}/sat/*.h
%{_includedir}/%{sname}/sat/detail/*.h
%{_includedir}/%{sname}/solver/*.h
%{_includedir}/%{sname}/solver/detail/*.h
%{_includedir}/%{sname}/target/*.h
%{_includedir}/%{sname}/target/modalias/*.h
%{_includedir}/%{sname}/target/rpm/*.h
%{_includedir}/%{sname}-tui/Application
%{_includedir}/%{sname}-tui/Config
%{_includedir}/%{sname}-tui/*.h
%{_includedir}/%{sname}-tui/output/PromptOptions
%{_includedir}/%{sname}-tui/output/*.h
%{_includedir}/%{sname}-tui/utils/*.h
%{_includedir}/%{sname}/ui/*.h
%{_includedir}/%{sname}/url/*.h
%{_includedir}/%{sname}/%{sname}_detail/*.h
%{_libdir}/%{name}.so
%{_libdir}/%{name}-tui.a
%{_libdir}/pkgconfig/%{name}.pc
%{_datadir}/cmake/Modules/*.cmake

#=============================================================================
%prep
%setup -q

#-----------------------------------------------------------------------------
#Adjusting libzypp to boost-1.82.0
sed -i							\
  -e "/^#include <iostream>/a #include <climits>"	\
  zypp-core/Pathname.cc					\
  zypp/PurgeKernels.cc
sed -i							\
  -e"/^#include <zypp\/MediaSetAccess.h>/i		\
      #define BOOST_TIMER_ENABLE_DEPRECATED"		\
  tools/DownloadFiles.cc

#-----------------------------------------------------------------------------
tar xf %{SOURCE1}

# Use correct libexecdir
find							\
  -type f						\
  -exec sed -i						\
    -e "s|/usr/lib/zypp|%{_libexecdir}/zypp|g" {} ';'

find							\
  -type f						\
  -exec sed -i						\
    -e "s|\${CMAKE_INSTALL_PREFIX}/lib/zypp|\${CMAKE_INSTALL_PREFIX}/libexec/zypp|g" {} ';'


#-----------------------------------------------------------------------------
%build

#canceling multiversion description (seems not to work)
sed -i							\
  -e"s/^multiversion\./#OK#multiversion\./"		\
  zypp.conf

cat >> zypp.conf << "EOF"
#-----------------------------------------------------------
#multiversion OSUKISS addon
multiversion = provides:multiversion(kernel)
multiversion.kernels = oldest,latest,latest-1,running
#-----------------------------------------------------------
EOF

cmake							\
	-B build					\
	-D CMAKE_INSTALL_PREFIX=%{_prefix}		\
	-D SYSCONFDIR=%{_sysconfdir}			\
	-D MANDIR=%{_mandir}				\
	-D CMAKE_BUILD_TYPE=Release			\
	-D CMAKE_SKIP_RPATH=1				\
	-D LIB=lib					\
	-D CMAKE_INSTALL_LIBEXECDIR=%{_libexecdir}	\
	-D ENABLE_BUILD_DOCS=FALSE			\
	-D ENABLE_BUILD_TRANS=TRUE			\
	-D ENABLE_BUILD_TESTS=TRUE			\
	-D DISABLE_AUTODOCS=ON				\
	-D DISABLE_MEDIABACKEND_TESTS=1			\
	.

#Preset Manual contents (avoid calling a2x)
%{__cp}							\
	%{name}-ok_addon/zypp-CheckAccessDeleted.1	\
	%{name}-ok_addon/zypp-NameReqPrv.1		\
	%{name}-ok_addon/locks.5			\
	build/doc

%define _smp_mflags -j%(/usr/bin/getconf _NPROCESSORS_ONLN)
%{__make}						\
	-C build					\
	%{?_smp_mflags}					\
	VERBOSE=0

%{__make}						\
	-C build/po					\
	translations					\
	VERBOSE=0 

%{__make}						\
	-C build/tests 					\
	VERBOSE=0 

#-----------------------------------------------------------------------------
%clean
%{__rm} -rf %{buildroot}

#-----------------------------------------------------------------------------
%check

%define	docheck 1
if [ -n "${docheck}" ] ; then
  pushd	build/tests
  LD_LIBRARY_PATH=%{buildroot}%{_libdir}:${LD_LIBRARY_PATH}	\
	ctest							\
	-VV							\
	--output-on-failure					\
	.
  popd
  fi
#-----------------------------------------------------------------------------
#installing program
%install
%{__rm} -rf %{buildroot}

%{__make}							\
	-C build						\
	DESTDIR=%{buildroot}					\
	install

%find_lang zypp

# Create directories expected by libzypp
%{__mkdir_p} %{buildroot}%{_sysconfdir}/%{sname}/repos.d
%{__mkdir_p} %{buildroot}%{_sysconfdir}/%{sname}/services.d
%{__mkdir_p} %{buildroot}%{_sysconfdir}/%{sname}/systemCheck.d
%{__mkdir_p} %{buildroot}%{_sysconfdir}/%{sname}/vendors.d
%{__mkdir_p} %{buildroot}%{_sysconfdir}/%{sname}/multiversion.d
%{__mkdir_p} %{buildroot}%{_sysconfdir}/%{sname}/needreboot.d
%{__mkdir_p} %{buildroot}%{_sysconfdir}/%{sname}/credentials.d
%{__mkdir_p} %{buildroot}%{_libexecdir}/%{sname}
%{__mkdir_p} %{buildroot}%{_libexecdir}/%{sname}/plugins
%{__mkdir_p} %{buildroot}%{_libexecdir}/%{sname}/plugins/appdata
%{__mkdir_p} %{buildroot}%{_libexecdir}/%{sname}/plugins/commit
%{__mkdir_p} %{buildroot}%{_libexecdir}/%{sname}/plugins/services
%{__mkdir_p} %{buildroot}%{_libexecdir}/%{sname}/plugins/system
%{__mkdir_p} %{buildroot}%{_libexecdir}/%{sname}/plugins/urlresolver
%{__mkdir_p} %{buildroot}%{_sharedstatedir}/%{sname}
%{__mkdir_p} %{buildroot}%{_localstatedir}/log/%{sname}
%{__mkdir_p} %{buildroot}%{_localstatedir}/cache/%{sname}

#-----------------------------------------------------------------------------
%changelog
